include "ZeroPage.inc"
include "Port.inc"
include "Vram.inc"
include "Chars.inc"

Width equ 6
Height equ 6

ext FortPattern
ext FortY_, FortCharOffset_
ext CharBuff
ext WaitVdp

pSource equ ZW0
wVram equ ZW1
yMod equ ZB0
cgCount equ ZB1
xCount equ ZB2

; void SetFortPattern()
cseg
SetFortPattern_: public SetFortPattern_
    pha
        lda FortY_
        and #7
        sta <yMod

        lda #$08 | sta <wVram+1
        lda FortCharOffset_
        clc|adc #Char_Fort
        asl a | rol <wVram+1 ;*2
        asl a | rol <wVram+1 ;*4
        asl a | rol <wVram+1 ;*8
        sta <wVram

        lda #2 | sta <cgCount
        do
            lda #low FortPattern | sta <pSource
            lda #high FortPattern | sta <pSource+1

            lda #Width | sta <xCount
            do
                sei
                    lda <wVram | sta VdpWritePort+1
                    lda <wVram+1 | sta VdpWritePort+1

                    lda #0
                    ldx <yMod
                    do | while ne
                        sta VdpWritePort
                        jsr WaitVdp
                        dex
                    wend
                    ldy #0
                    ldx #Height*CharHeight
                    do
                        lda (<pSource),y | iny
                        sta VdpWritePort
                        jsr WaitVdp
                        dex
                    while ne | wend
                    lda #0
                    ldx <yMod
                    do
                        sta VdpWritePort
                        jsr WaitVdp
                        inx
                        cpx #CharHeight
                    while ne | wend
                cli
                lda <pSource | clc|adc #low(CharHeight*Height) | sta <pSource
                lda <pSource+1 | adc #high(CharHeight*Height) | sta <pSource+1

                lda <wVram | clc|adc #low(CharHeight*(Height+1)) | sta <wVram
                lda <wVram+1 | adc #high(CharHeight*(Height+1)) | sta <wVram+1

                dec <xCount
            while ne | wend
            lda <wVram | clc|adc #low(-CharHeight*Width*(Height+1)) | sta <wVram
            lda <wVram+1 | adc #high(-CharHeight*Width*(Height+1))+8 | sta <wVram+1

            dec <cgCount
        while ne | wend
    pla
rts
