include "ZeroPage.inc"
include "Port.inc"
include "Vram.inc"
include "Chars.inc"
include "Stage.inc"

ext WaitVdp

Char_Count equ (Char_End-Char_Terrain)/2

ext charOffset_, dotOffset_
ext TerrainPattern_
ext Ground_

dseg
CharBuff: public CharBuff
    defs 8

pSource equ ZW0
wDestination equ ZW1
charCount equ ZB0
cgCount equ ZB1
dotCount equ ZB2

; void RollChar();
cseg
RollChar_: public RollChar_
    pha
        lda #0 | sta <wDestination+1
        lda #Char_Terrain | clc|adc charOffset_
        asl a | rol <wDestination+1 ;*2
        asl a | rol <wDestination+1 ;*4
        asl a | rol <wDestination+1 ;*8
        clc|adc #low(Vram_PatternGenerator) | sta <wDestination
        lda <wDestination+1 | adc #high(Vram_PatternGenerator) or $40 | sta <wDestination+1

        lda #low TerrainPattern_ | sta <pSource
        lda #high TerrainPattern_ | sta <pSource+1

        lda #Char_Count | sta <charCount
        do
            lda #3 | sta <cgCount
            do
                ldx #0
                ldy #0
                lda dotOffset_ | sta <dotCount
                lda (<pSource),y | iny
                inc <dotCount
                do 
                    dec <dotCount
                while ne
                    sta CharBuff,x | inx
                wend
                lda #8 | sec|sbc dotOffset_ | sta <dotCount
                lda (<pSource),y | iny
                do
                    sta CharBuff,x | inx
                    dec <dotCount
                while ne | wend
                sei
                    lda <wDestination | sta VdpWritePort+1
                    lda <wDestination+1 | ora #$20 | sta VdpWritePort+1
                    ldx #0
                    do
                        lda CharBuff,x | inx
                        sta VdpWritePort
                        jsr WaitVdp
                        cpx #8
                    while ne | wend
                cli

                ldx #0
                lda #2+7 | sec|sbc dotOffset_ | tay
                lda #8 | sta <dotCount
                do
                    lda (<pSource),y | iny
                    sta CharBuff,x | inx
                    dec <dotCount
                while ne | wend
                sei
                    lda <wDestination | sta VdpWritePort+1
                    lda <wDestination+1 | sta VdpWritePort+1
                    ldx #0
                    do
                        lda CharBuff,x | inx
                        sta VdpWritePort
                        jsr WaitVdp
                        cpx #8
                    while ne | wend
                cli
                lda <wDestination+1 | clc|adc #8 | sta <wDestination+1
                dec <cgCount
            while ne | wend
            lda <wDestination+1 | sec|sbc #8*3 | sta <wDestination+1
            lda <pSource | clc|adc #2+15 | sta <pSource
            lda <pSource+1 | adc #0 | sta <pSource+1
            lda <wDestination | clc|adc #CharHeight | sta <wDestination
            lda <wDestination+1 | adc #0 | sta <wDestination+1
            dec <charCount
        while ne | wend
    pla
rts


; void RollDown();
cseg
RollDown_: public RollDown_
	pha
        ldx #GroundWidth*(GroundHeight-1)
        do
            lda Ground_,x
            sta Ground_+GroundWidth,x
            dex
            cpx #$ff
        while ne | wend
	pla
rts