include "ZeroPage.inc"
include "Port.inc"
include "Vram.inc"
include "Chars.inc"

ext MonoPattern

pSource equ ZW0
wVram equ ZW0
wCount equ ZW1
count equ ZB0
VramH equ ZB1

dseg
VdpR2: public VdpR2
    defb 0
CurrentPage_: public CurrentPage_
    defw 0

cseg
CopyToVdp:
    do
        ldy #0
        do
            lda (<pSource),y | iny
            sta VdpWritePort
            jsr WaitVdp
            cpy #8
        while ne | wend
        lda <pSource | clc|adc #8 | sta <pSource
        lda <pSource+1 | adc #0 | sta <pSource+1
        dex
    while ne | wend
rts
ColorSource:
defb 64, $f0 ; Ascii
defb 16, $70 ; Logo
defb 4, $f0 ; Remain
defb 8, $a0 ; Barrier
defb 84, $70 ; Fort
defb 0
cseg
InitVram: public InitVram
    sei
        lda #0 | sta <VramH
        do
            lda #low Vram_PatternGenerator | sta VdpWritePort+1
            lda #$40 or high Vram_PatternGenerator | ora <VramH | sta VdpWritePort+1

            lda #low MonoPattern | sta <pSource
            lda #high MonoPattern | sta <pSource+1
            ldx #Char_Fort
            jsr CopyToVdp

            lda #low Vram_Color | sta VdpWritePort+1
            lda #$40 or high Vram_Color | ora <VramH | sta VdpWritePort+1
            ldx #0
            do
                lda ColorSource,x
            while ne
                sta <count
                inx
                lda ColorSource,x | inx
                do
                    ldy #8
                    do
                        sta VdpWritePort
                        jsr WaitVdp
                        dey
                    while ne | wend
                    dec <count
                while ne | wend
            wend
            
            lda <VramH | clc|adc #8 | sta <VramH
            cmp #8*3
        while ne | wend
    cli
    WaitVdp: public WaitVdp
rts


; void ClearScreen();
cseg
ClearScreen_: public ClearScreen_
    pha
        sei
            lda #low Vram_PatternName | sta VdpWritePort+1
            lda #$40 or high Vram_PatternName | sta VdpWritePort+1
            lda #Char_Space
            ldy #7
            do
                ldx #0
                do
                    sta VdpWritePort
                    jsr WaitVdp
                    dex
                while ne | wend
                dey
            while ne | wend
            lda #$06 | sta VdpR2 | sta VdpWritePort
            lda #$80+2 | sta VdpWritePort
        cli
        lda #low Vram_PatternName | sta CurrentPage_
        lda #high Vram_PatternName | sta CurrentPage_+1
    pla
rts


; word VramAddress(byte x, byte y);
dseg
VramAddress_@Param0: public	VramAddress_@Param0
VramAddress_.x_:
    defs 1
VramAddress_@Param1: public	VramAddress_@Param1
VramAddress_.y_:
    defs 1
cseg
VramAddress_: public VramAddress_
    pha
        lda #0 | sta <wVram+1
        lda	VramAddress_.y_
        asl	a ; *2
        asl	a ; *4
        asl	a | rol <wVram+1 ; *8
        asl	a | rol <wVram+1 ; *16
        asl	a | rol <wVram+1 ; *32

        clc|adc VramAddress_.x_ | tay
        lda <wVram+1 | adc #0 | tax

        tya | clc|adc CurrentPage_ | tay
        txa | adc CurrentPage_+1 | tax
	pla
rts


dseg
Put_@Param0: public Put_@Param0
Put_vram:
PrintC_@Param0: public PrintC_@Param0
PrintC_vram:
WriteVram_@Param0: public WriteVram_@Param0
WriteVram_vram:
ReadVram_@Param0: public ReadVram_@Param0
ReadVram_vram:
FillVram_@Param0: public FillVram_@Param0
FillVram_vram:
    defw 0
Put_@Param1: public Put_@Param1
Put_c:
PrintC_@Param1: public PrintC_@Param1
PrintC_c:
WriteVram_@Param1: public WriteVram_@Param1
WriteVram_c:
FillVram_@Param1: public FillVram_@Param1
FillVram_b:
    defb 0


; ptr<byte> Put(ptr<byte> wVram, byte c);
cseg
Put_: public Put_
    pha
        sei
            lda Put_vram | sta VdpWritePort+1
            lda Put_vram+1 | ora #$40 | sta VdpWritePort+1
            lda Put_c
            sta VdpWritePort
        cli
        lda Put_vram | clc|adc #1 | tay
        lda Put_vram+1 | adc #0 | tax
    pla
rts


; ptr<byte> PrintC(ptr<byte> wVram, byte c);
cseg
PrintC_: public PrintC_
    pha
        sei
            lda PrintC_vram | sta VdpWritePort+1
            lda PrintC_vram+1 | ora #$40 | sta VdpWritePort+1
            lda PrintC_c
            sec|sbc #$20
            sta VdpWritePort
        cli
        lda PrintC_vram | clc|adc #1 | tay
        lda PrintC_vram+1 | adc #0 | tax
    pla
rts


; void WriteVram(word vram, byte b);
cseg
WriteVram_: public WriteVram_
    sei
        lda WriteVram_vram | sta VdpWritePort+1
        lda WriteVram_vram+1 | ora #$40 | sta VdpWritePort+1
        lda WriteVram_c
        sta VdpWritePort
    cli
rts


; void SwitchPage();
cseg
SwitchPage_: public SwitchPage_
    pha
        lda VdpR2
        eor #$01
        sta VdpR2
        and #$01
        if ne
            ldy #low Vram_PatternName2
            ldx #high Vram_PatternName2
        else

            ldy #low Vram_PatternName
            ldx #high Vram_PatternName
        endif
        sty CurrentPage_ | stx CurrentPage_+1
    pla
rts


; void PresentPage();
cseg
PresentPage_: public PresentPage_
    pha
        lda VdpR2
        sei
            sta VdpWritePort+1
            ldx #$80+2 | stx VdpWritePort+1
        cli
    pla
rts