include "ZeroPage.inc"
include "Port.inc"
include "Vram.inc"
include "Chars.inc"
include "Stage.inc"

ext Ground_, GroundY_
ext Tiles_
ext CurrentPage_
ext WaitVdp
ext charOffset_

pSource equ ZW0
wVram equ ZW1
sourceX equ ZB0
yPos equ ZB1
xCount2 equ ZB2
yPos2 equ ZB3

; void DrawGround();
DrawGround_: public DrawGround_
    pha
        lda CurrentPage_ | sta <wVram
        lda CurrentPage_+1 | ora #$40 | sta <wVram+1

        ldx GroundY_
        do
            txa | and #$80
        while ne
            lda <wVram | sec|sbc #low VramWidth | sta <wVram
            lda <wVram+1 | sbc #high VramWidth | sta <wVram+1
            inx
        wend

        ldx #0 | stx <sourceX
        lda GroundY_ | sta <yPos
        do
            lda #GroundWidth | sta <xCount2
            do
                ldx <sourceX | lda Ground_,x | sta <pSource | inx | stx <sourceX

                lda #0 | sta <pSource+1
                asl <pSource | rol <pSource+1 ;*2
                asl <pSource | rol <pSource+1 ;*4
                asl <pSource | rol <pSource+1 ;*8
                asl <pSource | rol <pSource+1 ;*16
                lda <pSource | clc|adc #low Tiles_ | sta <pSource
                lda <pSource+1 | adc #high Tiles_ | sta <pSource+1

                lda <yPos | sta <yPos2
                ldx #TileSize
                do
                    lda <yPos2 | cmp #VramHeight
                    if cc
                        ldy #0
                        sei
                            lda <wVram | sta VdpWritePort+1
                            lda <wVram+1 | sta VdpWritePort+1
                            do
                                lda (<pSource),y
                                clc|adc charOffset_
                                sta VdpWritePort
                                jsr WaitVdp
                                iny
                                cpy #TileSize
                            while ne | wend
                        cli
                    endif
                    lda <wVram | clc|adc #low VramWidth | sta <wVram
                    lda <wVram+1 | adc #high VramWidth | sta <wVram+1
                    lda <pSource | clc|adc #TileSize | sta <pSource
                    lda <pSource+1 | adc #0 | sta <pSource+1
                    inc <yPos2
                    dex
                while ne | wend
                lda <wVram | clc|adc #low(TileSize-VramWidth*TileSize) | sta <wVram
                lda <wVram+1 | adc #high(TileSize-VramWidth*TileSize) | sta <wVram+1
                dec <xCount2
            while ne | wend
            lda <wVram | clc|adc #low(VramWidth*TileSize-VramWidth) | sta <wVram
            lda <wVram+1 | adc #high(VramWidth*TileSize-VramWidth) | sta <wVram+1
            lda <yPos | clc|adc #TileSize | sta <yPos
            cmp #VramHeight
        while cc | wend
	pla
rts
